Machines with > 16 drives not supported

Bug #335174 reported by Mark Bergsma on 2009-02-26
34
This bug affects 7 people
Affects Status Importance Assigned to Milestone
grub (Ubuntu)
High
Unassigned
grub2 (Ubuntu)
Medium
Unassigned
lilo (Ubuntu)
Medium
Joachim Wiedorn

Bug Description

Installations of Ubuntu on machines with more than 16 disks are currently not (fully) supported. If the boot device is not within the first 16 scsi block devices (/dev/sd[a-p]), the installation of boot loaders grub/grub2 and lilo fails.

<cjwatson> that sounds /* The rest is SCSI disks. */
<cjwatson> for (i = 0; i < 16; i++)

<cjwatson> wow, lilo has the exact same limitation, 16 disks

Log excerpt from a grub installation attempt with boot drives /dev/sdy and /dev/sdac:

Feb 26 21:30:44 grub-installer: Probing devices to guess BIOS drives. This may take a long time.
Feb 26 21:30:45 grub-installer: /dev/sdy1 does not have any corresponding BIOS drive.
Feb 26 21:30:45 grub-installer: error: Running 'grub-install --no-floppy "(hd0)"' failed.
Feb 26 21:30:45 debconf: --> SUBST grub-installer/grub-install-failed BOOTDEV (hd0)

Colin Watson (cjwatson) on 2009-02-27
Changed in grub2:
assignee: nobody → cjwatson
importance: Undecided → Medium
status: New → Triaged
Changed in grub:
assignee: nobody → cjwatson
importance: Undecided → High
status: New → Triaged
Changed in lilo:
assignee: nobody → cjwatson
importance: Undecided → Medium
status: New → Triaged
Colin Watson (cjwatson) on 2009-03-04
Changed in grub:
status: Triaged → Fix Committed
Mark Bergsma (mark-wikimedia) wrote :

The issue appears not to be fully addressed by the committed fix; an Ubuntu install still fails if the boot device is not within the first 7 disks:

# chroot /target grub-install --no-floppy "(hd24)"
Searching for GRUB installation directory ... found: /boot/grub
The file /boot/grub/stage1 not read correctly.

A strace seems to indicate that the "dump" command fails. Some debugging:

grub> dump (hd7)/boot/grub/stage1 /tmp/grubtest
dump (hd7)/boot/grub/stage1 /tmp/grubtest
Error 17: Cannot mount selected partition

grub> dump (hd8)/boot/grub/stage1 /tmp/grubtest
dump (hd8)/boot/grub/stage1 /tmp/grubtest
Error 12: Invalid device requested

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package grub - 0.97-29ubuntu51

---------------
grub (0.97-29ubuntu51) jaunty; urgency=low

  [ Colin Watson ]
  * more_scsi_disks.diff: Add support for up to 256 SCSI disk devices on
    Linux (LP: #335174). Due to BIOS disk numbering only at most 128 can be
    bootable, so ensure we don't crash if there are more.

  [ Colin King ]
  * ext4_fix_variable_sized_inodes.diff: Add support for ext4 variable
    sized inodes (LP: #345488). This is backwardly compatible with ext2
    ext3 fixed sized inodes.

 -- Colin Watson <email address hidden> Fri, 20 Mar 2009 16:12:22 +0000

Changed in grub:
status: Fix Committed → Fix Released
Colin Watson (cjwatson) wrote :

sane_partition restricts to eight drives, apparently for some reason related to floppy support; see e.g.:

  http://<email address hidden>/msg00525.html

Reopening.

Changed in grub (Ubuntu):
status: Fix Released → Triaged
Robert Millan (rmh-aybabtu) wrote :

Hi,

I fixed this in SVN for IDE, Xen, Virtio and SCSI. The upper limit is 26 now.

In the future, please don't hesitate to notify <email address hidden> about such issues.

On Tue, Jun 09, 2009 at 02:43:41PM -0000, Robert Millan wrote:
> I fixed this in SVN for IDE, Xen, Virtio and SCSI. The upper limit is
> 26 now.

That's still lower than it ought to be, for SCSI at least.

> In the future, please don't hesitate to notify <email address hidden> about
> such issues.

I did, and you replied, although unfortunately I'm still pending
assignment paperwork in order to do anything more significant:

  http://lists.gnu.org/archive/html/grub-devel/2009-03/msg00080.html

Colin Watson (cjwatson) on 2011-01-19
Changed in grub (Ubuntu):
assignee: Colin Watson (cjwatson) → nobody
Changed in lilo (Ubuntu):
assignee: Colin Watson (cjwatson) → nobody
Joachim Wiedorn (ad-debian) wrote :

Bug were solved with lilo upstream version 23.2.
Solved for "Oneiric Ocelot" version.

Changed in lilo (Ubuntu):
assignee: nobody → Joachim Wiedorn (ad-debian)
status: Triaged → Fix Released
Colin Watson (cjwatson) on 2012-05-18
Changed in grub2 (Ubuntu):
assignee: Colin Watson (cjwatson) → nobody
Phillip Susi (psusi) wrote :

It seems to work fine these days with grub2. Installed to /dev/sdq in a vm. The code Collin identified as problematic appears to have been removed.

Changed in grub2 (Ubuntu):
status: Triaged → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers